﻿using Kivii.Lims.Entities;
using Kivii.Linq;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Lac.Lims
{
    public static class SampleExtension
    {
        /// <summary>
        /// 获取子样品的流水号
        /// </summary>
        /// <param name="sample"></param>
        /// <param name="conn"></param>
        /// <returns></returns>
        [Obsolete("此方法过期")]
        public static string GetSubSerialNumber(this Sample sample, IDbConnection conn = null)
        {
            sample.RootKvid.ThrowIfEmpty("RootKvid不能为空");
            if (conn == null) conn = KiviiContext.GetOpenedDbConnection<Sample>();
            var rootSample = conn.SingleById<Sample>(sample.RootKvid);
            rootSample.ThrowIfNull("主样品不存在");
            var allcount = conn.Count<Sample>(o => o.RootKvid == rootSample.Kvid);
            //allcount不需要加1，因为Root的也统计进去了
            return $"{rootSample.SerialNumber}-{allcount}";
        }
    }
}
